package org.example;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

@RestController
public class EmployeeController {

    private EmployeeRepository employeeRepository;

    public EmployeeController(EmployeeRepository employeeRepository) {
        this();
        this.employeeRepository = employeeRepository;
    }

    public EmployeeController() {

    }

    @GetMapping("/employee/data")
    public ResponseEntity<Page<Employee>> getData(@RequestParam(defaultValue = "0") int page,
                                                     @RequestParam(defaultValue = "10") int size) {
        List<Employee> empList = listImplementation();


        int totalSize = empList.size();
        int startIndex = page * size;
        int endIndex = Math.min(startIndex + size, totalSize);

        List<Employee> pageContent = empList.subList(startIndex, endIndex);

        Page<Employee> employeeDtos = new PageImpl<>(pageContent, PageRequest.of(page, size), totalSize);

        return ResponseEntity.ok()
                .body(employeeDtos);
    }

    private static List<Employee> listImplementation() {
        List<Employee> empList = new ArrayList<>();
        empList.add(new Employee("Jane", "Finance"));
        empList.add(new Employee("Sarah", "IT"));
        empList.add(new Employee("John", "IT"));
        return empList;
    }

}