package org.example;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.web.client.TestRestTemplate;
import org.springframework.core.ParameterizedTypeReference;
import org.springframework.http.HttpMethod;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.test.context.ActiveProfiles;

import java.util.List;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertNotNull;

@SpringBootTest(webEnvironment = SpringBootTest.WebEnvironment.RANDOM_PORT)
@ActiveProfiles("test")
public class EmployeeClientIntegrationTest<T> {

    @Autowired
    private TestRestTemplate restTemplate;

    @Test
    public void testFetchEmployeeData() {
        ResponseEntity<CustomPageImpl<EmployeeController>> responseEntity = restTemplate.exchange(
                "/employee/data?page=0&size=10",
                HttpMethod.GET,
                null,
                new ParameterizedTypeReference<CustomPageImpl<EmployeeController>>() {
                }
        );

        assertEquals(HttpStatus.OK, responseEntity.getStatusCode());
        CustomPageImpl<EmployeeController> employeePage = responseEntity.getBody();
        assertNotNull(employeePage);

        List<EmployeeController> content = employeePage.getContent();
        assertNotNull(content);
        assertEquals(10, content.size());
    }

}